<template lang="pug">
.q-mr-lg
  .row
    .col-md.col-12
      .row.fit.q-col-gutter-md
        .col-3(v-for="room in boRooms")
          q-card(flat, bordered, :disabled="roomSpeakersIsDisabled(room)")
            keep-alive
              Breakout(
                :firebase="firebase",
                :functions="functions",
                :context="getContext(room)"
              )

    .col-md-2.col-12(:class="{ 'order-first': $q.screen.lt.md }")
      .text-strong {{ boLength(TimeRange) }}
      q-stepper(
        alternative-labels,
        flat,
        v-model="step",
        ref="stepper",
        color="primary",
        animated,
        vertical,
        @input="navTo(step)",
        :header-nav="true"
      )
        q-step(
          :header-nav="false",
          name="start",
          :title="`Started (${StartTime})`",
          icon="play_arrow"
        )
        q-step(
          :done-icon="getTimelineIcon(h)",
          :active-icon="getTimelineIcon(h)",
          :done="h == history",
          v-for="h in historyList",
          :key="h",
          :name="h",
          :title="getTimelineTitle(h)",
          :icon="getTimelineIcon(h)"
        )
        q-step(
          v-if="!meeting.actualEndTime",
          done-icon="play_arrow",
          active-icon="play_arrow",
          active-color="red-7",
          :done="history == 0",
          :name="0",
          title="Live",
          icon="play_arrow"
        )
        q-step(
          v-if="meeting.actualEndTime",
          done-icon="stop",
          active-icon="stop",
          :name="-1",
          :title="EndTime",
          icon="stop",
          :header-nav="false"
        )
</template>

<script>
import { roundHistory, lookupRealHistory } from "@/shared";
import moment from "moment-timezone";

export default {
  name: "MeetingDetailsDynamic",
  props: {
    meetingId: {},
    context: {},
    functions: {},
    firebase: {},
    plugins: {},
  },
  data: function () {
    return {
      history: 0,
      boList: {},
      meeting: {},
      activeSpeakers: [],
      chats: { loading: true },
      distributedDocs: {},
      step: 0,
      timezone: moment.tz.guess(),
      showLogs: false,
    };
  },
  watch: {
    history: {
      immediate: true,
      handler(h) {
        if (h == 0 && this.meeting && this.meeting.actualEndTime) {
          this.history = this.historyList[this.historyList.length - 1];
        }

        if (h == "") {
          this.step = 0;
        }
      },
    },
    meetingId: {
      immediate: true,
      async handler(id) {
        await this.$rtdbBind(
          "boList",
          this.firebase.ref(`data/logs/boMeta/${id}`)
        );

        if (this.history == 0)
          this.history = this.historyList[this.historyList.length - 1];
      },
    },
  },
  computed: {
    // user() {
    //   return auth.currentUser;
    // },
    TimeRange: function () {
      try {
        // let events = [];

        var initialLatestTime = -1;
        var initialEarliestTime = 9999999999999999999;

        // find the latest and earliest timestamp from each bot
        let latesttime = initialLatestTime;
        let earliestime = initialEarliestTime;

        //find the history entry before this one (if there is one):
        let currentIndex = this.historyList.indexOf(parseInt(this.history));
        // console.log(currentIndex, this.history, this.historyList);
        let lastHistory = this.historyList[currentIndex - 1];
        // console.log(lastHistory);
        earliestime = lastHistory;

        // console.log(this.history);

        // if (typeof lastHistory === "undefined") {

        if (currentIndex - 1 == -1) {
          // console.log(moment(this.meeting.startTime));
          earliestime = moment(this.meeting.startTime).toDate();
        }

        if (this.history == 0) {
          earliestime = this.historyList[this.historyList.length - 1];
        }

        // if (currentIndex == this.historyList.length -1)
        // {

        // }
        // }

        for (let bot of Object.keys(this.boList)) {
          let rh = lookupRealHistory(this.history, this.boList[bot]);

          // console.log(bot);

          if (rh != -1 && rh > latesttime) latesttime = rh;
        }

        if (
          latesttime === initialLatestTime &&
          earliestime === initialEarliestTime
        ) {
          // if nothing is set, make sure we put a valid date in
          latesttime = new Date(this.meeting.startTime);
          earliestime = new Date(this.meeting.endTime);
        }

        return [latesttime, earliestime];
      } catch (e) {
        return [0, 0];
      }
    },
    EndTime: function () {
      return moment(this.meeting.actualEndTime)
        .tz(this.timezone)
        .format("h:mma");
    },
    StartTime: function () {
      return moment(this.meeting.startTime).tz(this.timezone).format("h:mma");
    },
    MeetingLength: function () {
      var duration = moment.duration(
        moment(new Date(this.meeting.endTime)).diff(
          moment(new Date(this.meeting.startTime))
        )
      );
      return duration.asMinutes();
    },
    TimeString: function () {
      var now = new Date();
      var starts = new Date(this.meeting.startTime);
      var ends = new Date(this.meeting.endTime);

      var startString = moment(new Date(this.meeting.startTime))
        .tz(this.timezone)
        .fromNow();

      if (ends < now) {
        return (
          "Ended " +
          moment(new Date(this.meeting.endTime)).tz(this.timezone).fromNow()
        );
      }
      if (starts < now) {
        return "Started " + startString;
      }

      return "Starts " + startString;
    },
    historyList() {
      const allHistory = new Set();
      // console.log(this.boList);
      for (const val of Object.values(this.boList)) {
        // zoomBotWithHistory => {
        // console.log(key);
        // if (!zoomBotWithHistory) return;
        for (const historyKey in val) {
          // We only add a history node if it has a userlist
          // if (zoomBotWithHistory[historyKey].userList) {
          allHistory.add(roundHistory(historyKey));
          // }
        }
      }
      return [...(allHistory || [])].sort();
    },
    boRooms() {
      return Object.keys(this.boList);
    },

    //
  },
  methods: {
    getContext(bo) {
      return { ...this.context, ...{ history: this.history, room: bo } };
    },

    latestTime(botevents) {
      let sorted = botevents.map((f) => f.timestamp).sort();
      return [sorted[sorted.length - 1], sorted[0]];
    },
    boLength(bo) {
      if (this.history == 0) {
        return `${moment
          .unix(bo[1] / 1000)
          .tz(this.timezone)
          .format("h:mma")} - Now (${moment
          .duration(moment().diff(moment.unix(bo[1] / 1000)))
          .humanize()})`;
      } else
        return `${moment
          .unix(bo[1] / 1000)
          .tz(this.timezone)
          .format("h:mma")} - ${moment
          .unix(bo[0] / 1000)
          .tz(this.timezone)
          .format("h:mma")} (${moment
          .duration(moment.unix(bo[0] / 1000).diff(moment.unix(bo[1] / 1000)))
          .humanize()})`;
    },
    navTo(h) {
      if (h == 0) h = "";
      this.history = h;
    },

    ifBOSessionTitle(index) {
      if (index == "ZoomSensor_1") {
        return this.isBOSession(this.history) ? "" : "Main Session";
      } else return "";
    },
    getTimelineIcon(h) {
      return this.isBOSession(h) ? "group_work" : "people";
    },
    getTimelineTitle(h) {
      var category = this.isBOSession(h) ? "Breakouts" : "Main";
      var minutesLength = 0;

      var historyIndex = this.historyList.indexOf(h);

      // get segment length in minutes
      if (historyIndex == 0) {
        minutesLength =
          (h - moment(this.meeting.startTime).valueOf()) / 1000 / 60;
      } else {
        minutesLength = (h - this.historyList[historyIndex - 1]) / 1000 / 60;
      }

      return category + " (" + minutesLength + " mins)";
    },
    isBOSession(h) {
      //this history item needs to ONLY be in ZoomSensor_1

      let counter = 0;
      for (let bo of Object.keys(this.boList)) {
        // console.log(this.realhistoryindex(this.boList[bo], h));
        if (this.realhistoryindex(this.boList[bo], h) !== -1) counter++;
      }

      if (counter > 1) return true;
      else return false;
    },

    meetingFinished() {
      return moment(this.meeting.endTime).toDate() < moment().toDate();
    },

    realhistoryindex(bot, index) {
      // loop through and find the key that matches:
      if (bot) {
        let keys = Object.keys(bot);
        for (let el of keys) {
          if (roundHistory(el) == parseInt(index)) {
            return el;
          }
        }
        return -1;
      } else {
        return 0;
      }
    },

    roomSpeakersIsDisabled(room) {
      const realHistory = lookupRealHistory(this.history, this.boList[room]);

      if (realHistory === -1) return true;
      else return false;
    },
  },
  created: function () {
    this.step = this.history;
  },
};
</script>

<style>
.meetingPage {
  margin-top: 1em;
}

.q-stepper--horizontal .q-stepper__step-inner {
  display: none !important;
}
</style>
